#define negative 1
#define positive 0

void initializeGAM(void);
void readGAM(void);

void initializeGAM(void) {
    startI2C();
    putI2C(GAM_WRITE & 0xFE);
    putI2C(0x1F);
    putI2C(0b00111000);
    stopI2C();
    startI2C();
    putI2C(GAM_WRITE & 0xFE);
    putI2C(0x20);
    putI2C(0b11000000);
}
void readGAM(void) {
    int x_high = 0x00;
    int x_low = 0x00;
    int y_high = 0x00;
    int y_low = 0x00;
    int z_high = 0x00;
    int z_low = 0x00;
    int check = 0x00;
    int xsign;
    int ysign;
    int zsign;
    float xacc_final;
    float yacc_final;
    float zacc_final;
    while ((check & 0x01) == 0) {
        startI2C();
        putI2C(GAM_WRITE & 0xFE);
        putI2C(0x27);
        startI2C();
        putI2C(GAM_READ |0x01);
        check = getI2C(1);
        stopI2C();
    }
    startI2C();
    putI2C(GAM_WRITE & 0xFE);
    putI2C(0x28);
    startI2C();
    putI2C(GAM_READ | 0x01);
    x_high = getI2C(0);
    x_low = getI2C(0);
    y_high = getI2C(0);
    y_low = getI2C(0);
    z_high = getI2C(0);
    z_low = getI2C(1);
    stopI2C();
    
    int xacc =  x_high << 8 | x_low;
    int yacc =  y_high << 8 | y_low;
    int zacc =  z_high << 8 | z_low;
    if ((xacc & 0x8000) == 0){
        xsign = positive;
    }
    if ((yacc & 0x8000) == 0){
        ysign = positive;
    }
    if ((zacc & 0x8000) == 0){
        zsign = positive;
    }
    xacc = xacc & 0x7FFF;
    yacc = yacc & 0x7FFF;
    zacc = zacc & 0x7FFF;
    xacc_final = ((float) xacc*2)/((float) 0x7FFF);
    yacc_final = ((float) yacc*2)/((float) 0x7FFF);
    zacc_final = ((float) zacc*2)/((float) 0x7FFF);
    if (xsign != positive) {
        xacc_final = -xacc_final;
    }
    if (ysign != positive) {
        yacc_final = -yacc_final;
    }
    if (zsign != positive) {
        zacc_final = -zacc_final;
    }
    if (xacc_final < 0) {
    printf("the acceleration in the x direction is %f \n\r", xacc_final);
    printf("the acceleration in the y direction is %f \n\r", yacc_final);
    printf("the acceleration in the z direction is %f \n\r", zacc_final);  
    }
    else if (yacc_final < 0) {
    printf("the acceleration in the x direction is %f \n\r", xacc_final);
    printf("the acceleration in the y direction is %f \n\r", yacc_final);
    printf("the acceleration in the z direction is %f \n\r", zacc_final);         
    }
    else if (zacc_final < 0) {
    printf("the acceleration in the x direction is %f \n\r", xacc_final);
    printf("the acceleration in the y direction is %f \n\r", yacc_final);
    printf("the acceleration in the z direction is %f \n\r", zacc_final);         
    }
}
