/* 
 * File:   I2C_function.h
 * Author: John
 *
 * Created on February 4, 2018, 2:15 PM
 */
#define MST_INT IFS1bits.I2C4MIF
void configI2C();
int startI2C();
int putI2C(int data);
void stopI2C(void);
void rstartI2C(void);
unsigned char getI2C(int ack2send);

void configI2C() { // configure I2C communication
    //printf("Configuring I2C");
    I2C4BRG = 0x02F;
    I2C4CONbits.ON = 1;
    printf("Configure I2C Complete\n\r");
}
int startI2C() {
    MST_INT = 0;
    I2C4CONbits.SEN = 1;
    while (!MST_INT); //wait for communication from I2

}
int putI2C(int data) {//send data to I2C
    MST_INT = 0;
    I2C4TRN = data;
    while(!MST_INT);
    return(I2C4STATbits.ACKSTAT);
}
void stopI2C(void) { //turn off I2C
    MST_INT = 0;
    I2C4CONbits.PEN = 1;
    while(!MST_INT); //wait for response
}
void rstartI2C(void) {
    MST_INT = 0;
    I2C4CONbits.RSEN = 1;
    while(!MST_INT);
}
unsigned char getI2C(int ack2send) { //get response from I2C
    MST_INT = 0;
    unsigned char inByte;
    I2C4CONbits.RCEN = 1;
    while(!MST_INT);
    MST_INT = 0;
    inByte = I2C4RCV;
    I2C4CONbits.ACKEN = 1;
    I2C4CONbits.ACKDT = ack2send;
    while(!MST_INT);
    return(inByte);
}