void initializeAlt(void);
void readAlt(void);
float convertPressure(int P_high, int P_mid, float P_low);
#define ALT_CTRL_REG1 0x26
#define ALT_STATUS 0x06

void initializeAlt(void) {
    int reg_1_data = 0x00;
    int PT_DATA = 0x00;
    int reg_1_ACTIVE = 0x00;
    while (reg_1_data != 0xB8){
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(ALT_CTRL_REG1);
        putI2C(0xB8);
        stopI2C();
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(ALT_CTRL_REG1);
        startI2C();
        putI2C(ALT_READ |0x01);
        reg_1_data = getI2C(1);
        stopI2C();
    }
    while (PT_DATA != 0x07) {
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(0x13);
        putI2C(0x07);
        stopI2C();
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(0x13);
        startI2C();
        putI2C(ALT_READ | 0x01);
        PT_DATA = getI2C(1);
        stopI2C();
    }
    while (reg_1_data != 0xB9){
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(ALT_CTRL_REG1);
        putI2C(0xB9);
        stopI2C();
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(ALT_CTRL_REG1);
        startI2C();
        putI2C(ALT_READ |0x01);
        reg_1_data = getI2C(1);
        stopI2C();
    }
}
void readAlt(void) {
    int check = 0x00;
    int OUT_P_MSB;
    int OUT_P_CSB;
    float OUT_P_LSB;
    float OUT_T_MSB;
    float OUT_T_LSB;
    float newPressure;
    while (check & 0b00001000 > 0){
        startI2C();
        putI2C(ALT_WRITE & 0xFE);
        putI2C(0x00);
        startI2C();
        putI2C(ALT_READ | 0x01);
        check = getI2C(1);
        stopI2C();   
        printf("check = %i \n\r", check);
    }
    startI2C();
    putI2C(ALT_WRITE & 0xFE);
    putI2C(0x01);
    startI2C();
    putI2C(ALT_READ | 0x01);
    OUT_P_MSB = getI2C(0);
    OUT_P_CSB = getI2C(0);
    OUT_P_LSB = getI2C(1);
    stopI2C();
    newPressure = convertPressure(OUT_P_MSB, OUT_P_CSB,OUT_P_LSB);
    printf("Current Altitude = %f meters \n\r", newPressure);
}

float convertPressure(int P_high, int P_mid, float P_low){
    int sign;
    int count;
    float TOTAL;
    if (P_high > 0x7F) {
        sign = 1;
    }
    else {
        sign = 0;
    }
    TOTAL = (long) P_high << 8 | P_mid;
    for (count = 0; count<8; count++) { //convert LSB to decimal
        P_low = P_low/2;
    }
    TOTAL = TOTAL + P_low;
    return TOTAL;
}