/* 
 * File:   interrupt_config_UART_GPS.h
 * Author: John
 *
 * Created on March 20, 2018, 4:57 PM
 */

#ifndef INTERRUPT_CONFIG_UART_GPS_H
#define	INTERRUPT_CONFIG_UART_GPS_H

#include "config.h"

// GPS UART (UART 2)
#define GPS_UART_Transmit_Interrupt_Flag UART_6_Transmit_Interrupt_Flag
#define GPS_UART_Transmit_Interrupt_Mode_Select UART_6_Transmit_Interrupt_Mode_Select
#define GPS_UART_Receive_Interrupt_Flag UART_6_Receive_Interrupt_Flag
#define GPS_UART_Receive_Interrupt_Mode_Select UART_6_Receive_Interrupt_Mode_Select
#define GPS_UART_Error_Interrupt_Flag UART_6_Error_Interrupt_Flag
#define GPS_UART_Parity_Error_Status UART_6_Parity_Error_Status
#define GPS_UART_Framing_Error_Status UART_6_Framing_Error_Status
#define GPS_UART_Receive_Buffer_Overflow_Status UART_6_Receive_Buffer_Overflow_Status
#define GPS_UART_Interrupt_Priority UART_6_Interrupt_Priority
#define GPS_UART_Interrupt_Subpriority UART_6_Interrupt_Subpriority
#define GPS_UART_Transmit_Interrupt_Enable UART_6_Transmit_Interrupt_Enable

#define GPS_UART_Error_Interrupt_Enable UART_6_Error_Interrupt_Enable

char lat_degree[2];
char lat_minute[7];
char latitude_dir;
char long_degree[3];
char long_minute[7];
char longitude_dir;
char GPS_state_check[3] = {'X','X','X'};
int state_check_index = 0;
int readDataIndex = 0;
bool readGPSData = false;
int countCommas = 0;
int skipFirstChar = 0;
UART_Interrupt(GPS_UART,UART_6,Interrupt,6,1,
        /*tx interrupts*/disabled,
        /*rx interrupts*/disabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
// pc_uart_just_printed_debug_info = true;
// printf("\n\rvoid GPS_UART_Interrupt_Event()");

 if(GPS_UART_Transmit_Interrupt_Enable && GPS_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {
  printf("\n\r\tUART Transmit Interrupt");
  GPS_UART_Transmit_Interrupt_Flag = false; // clear flag
 } 
 if(GPS_UART_Receive_Interrupt_Enable && GPS_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
     /********************************/
  char c = getU6();
  putU1(c);
  GPS_state_check [0] = GPS_state_check[1];
  GPS_state_check [1] = GPS_state_check[2];
  GPS_state_check [2] = c;
  if (GPS_state_check[2] == ',' && GPS_state_check[1] == ',') {
      readGPSData = false;
      countCommas = 0;
      GPS_UART_Receive_Interrupt_Enable = 0;
  }
  if (GPS_state_check[0] == 'G' && GPS_state_check[1] == 'G' && GPS_state_check[2] == 'A'){
      readGPSData = true;
  }
  if (readGPSData == true){
      if (c == ','){
          countCommas = countCommas + 1;
      }
  }
    if (readGPSData == true){
        switch (countCommas) {
            case 2:
                if (skipFirstChar == 0) {
                   skipFirstChar =1;
                }
                else {
                    if (readDataIndex < 2) {
                        lat_degree[readDataIndex] = c;
                        readDataIndex = readDataIndex + 1;
                    }
                    else if (readDataIndex >1 && readDataIndex < 9) {
                        lat_minute[readDataIndex - 2] = c;
                        readDataIndex = readDataIndex + 1;
                        if (readDataIndex == 9) {
                            readDataIndex = 0;
                            skipFirstChar = 0;
                        }
                    }
                }
                break;
            case 3:
                if (skipFirstChar == 0){
                    skipFirstChar = 1;
                }
                else {
                    latitude_dir = c;
                    skipFirstChar = 0;
                    readDataIndex = 0;
                }
                break;
            case 4:
                if (skipFirstChar == 0){
                    skipFirstChar = 1;
                }
                else {
                    if (readDataIndex < 3) {
                        long_degree[readDataIndex] = c;
                        readDataIndex = readDataIndex + 1;
                    }
                    else if (readDataIndex > 2 && readDataIndex < 10) {
                        long_minute[readDataIndex - 3] = c;
                        readDataIndex = readDataIndex + 1;
                        if (readDataIndex == 10) {
                            readDataIndex = 0;
                            skipFirstChar = 0;
                        }
                    }
                }
                break;
            case 5:
                if (skipFirstChar == 0){
                    skipFirstChar = 1;
                }
                else {
                    longitude_dir = c;
                    skipFirstChar = 0;
                    readDataIndex = 0;
                }
                break;
            case 6:
                skipFirstChar = 0;
                countCommas = 0;
                readDataIndex = 0;
                readGPSData = false;
                GPS_UART_Receive_Interrupt_Enable = 0;
                break;
        }
    }
}
  GPS_UART_Error_Interrupt_Flag = false; // clear flag
 }

#endif	/* INTERRUPT_CONFIG_UART_GPS_H */

