/* 
 * File:   interrupt_config_UART_GPS_VER2.h
 * Author: John
 *
 * Created on March 20, 2018, 4:57 PM
 */

#ifndef INTERRUPT_CONFIG_UART_GPS_VER2_H
#define	INTERRUPT_CONFIG_UART_GPS_VER2_H

#include "config.h"

// GPS UART (UART 2)
#define GPS_UART_Transmit_Interrupt_Flag UART_6_Transmit_Interrupt_Flag
#define GPS_UART_Transmit_Interrupt_Mode_Select UART_6_Transmit_Interrupt_Mode_Select
#define GPS_UART_Receive_Interrupt_Flag UART_6_Receive_Interrupt_Flag
#define GPS_UART_Receive_Interrupt_Mode_Select UART_6_Receive_Interrupt_Mode_Select
#define GPS_UART_Error_Interrupt_Flag UART_6_Error_Interrupt_Flag
#define GPS_UART_Parity_Error_Status UART_6_Parity_Error_Status
#define GPS_UART_Framing_Error_Status UART_6_Framing_Error_Status
#define GPS_UART_Receive_Buffer_Overflow_Status UART_6_Receive_Buffer_Overflow_Status
#define GPS_UART_Interrupt_Priority UART_6_Interrupt_Priority
#define GPS_UART_Interrupt_Subpriority UART_6_Interrupt_Subpriority
#define GPS_UART_Transmit_Interrupt_Enable UART_6_Transmit_Interrupt_Enable

#define GPS_UART_Error_Interrupt_Enable UART_6_Error_Interrupt_Enable


char GPS_state_check[3] = {'X','X','X'};
int state_check_index = 0;
int readDataIndex = 0;
bool readGPSData = false;
bool startRecording = false;
int countCommas = 0;
int skipFirstChar = 0;
UART_Interrupt(GPS_UART,UART_6,Interrupt,6,1,
        /*tx interrupts*/disabled,
        /*rx interrupts*/disabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
// pc_uart_just_printed_debug_info = true;
// printf("\n\rvoid GPS_UART_Interrupt_Event()");

 if(GPS_UART_Transmit_Interrupt_Enable && GPS_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {
  printf("\n\r\tUART Transmit Inter3333333rupt");
  GPS_UART_Transmit_Interrupt_Flag = false; // clear flag
 } 
 if(GPS_UART_Receive_Interrupt_Enable && GPS_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
     /********************************/
     int errorCheck;
     if (U6STAbits.OERR == 1) {
         U6STAbits.OERR = 0;
     }
  char c = getU6();
  putU1(c);
  GPS_state_check [0] = GPS_state_check[1];
  GPS_state_check [1] = GPS_state_check[2];
  GPS_state_check [2] = c;
  if (GPS_state_check[2] == ',' && GPS_state_check[1] == ',') {
      readGPSData = false;
      countCommas = 0;
  }
  if (GPS_state_check[0] == 'G' && GPS_state_check[1] == 'G' && GPS_state_check[2] == 'A'){
      readGPSData = true;
  }
  if (readGPSData == true){
      if (c == ','){
          countCommas = countCommas + 1;
          if (countCommas == 2) {
              startRecording = true;
          }
      }
      if (startRecording) {
          if (c != ',' && countCommas < 6) {
              totalAttempt[readDataIndex] = c;
              readDataIndex = readDataIndex+1;
          }
          if (countCommas == 9 && c !=',') {
              totalAttempt[readDataIndex] = c;
              readDataIndex = readDataIndex + 1;
          }
          if (countCommas ==10){
              readDataIndex = 0;
              startRecording = false;
              readGPSData = false;
              GPS_UART_Receive_Interrupt_Enable = 0;
              countCommas = 0;
              newDataRead = true;
          }
      }
      
    }
}
  GPS_UART_Error_Interrupt_Flag = false; // clear flag
 }

#endif	/* INTERRUPT_CONFIG_UART_GPS_H */

