/* 
 * File:   interrupt_config_UART_LoRa.h
 * Author: cstgeo
 *
 * Created on February 11, 2018, 2:35 PM
 */

#ifndef INTERRUPT_CONFIG_UART_LORA_H
#define	INTERRUPT_CONFIG_UART_LORA_H
#include "config.h"

// LoRa UART (UART 2)
#define LoRa_UART_Transmit_Interrupt_Flag UART_2_Transmit_Interrupt_Flag
#define LoRa_UART_Transmit_Interrupt_Mode_Select UART_2_Transmit_Interrupt_Mode_Select
#define LoRa_UART_Receive_Interrupt_Flag UART_2_Receive_Interrupt_Flag
#define LoRa_UART_Receive_Interrupt_Mode_Select UART_2_Receive_Interrupt_Mode_Select
#define LoRa_UART_Error_Interrupt_Flag UART_2_Error_Interrupt_Flag
#define LoRa_UART_Parity_Error_Status UART_2_Parity_Error_Status
#define LoRa_UART_Framing_Error_Status UART_2_Framing_Error_Status
#define LoRa_UART_Receive_Buffer_Overflow_Status UART_2_Receive_Buffer_Overflow_Status
#define LoRa_UART_Interrupt_Priority UART_2_Interrupt_Priority
#define LoRa_UART_Interrupt_Subpriority UART_2_Interrupt_Subpriority
#define LoRa_UART_Transmit_Interrupt_Enable UART_2_Transmit_Interrupt_Enable
#define LoRa_UART_Receive_Interrupt_Enable UART_2_Receive_Interrupt_Enable
#define LoRa_UART_Error_Interrupt_Enable UART_2_Error_Interrupt_Enable



UART_Interrupt(LoRa_UART,UART_2,Interrupt,6,1,
        /*tx interrupts*/disabled,
        /*rx interrupts*/enabled,
        /*err interrupts*/disabled,
        UART_Transmit_Interrupt_Mode.Buffer_Just_Emptied,
        UART_Receive_Interrupt_Mode.Buffer_Not_Empty) {
// pc_uart_just_printed_debug_info = true;
// printf("\n\rvoid LoRa_UART_Interrupt_Event()");
 if(LoRa_UART_Transmit_Interrupt_Enable && LoRa_UART_Transmit_Interrupt_Flag) // Transmitter-buffer-empty interrupt
 {
  printf("\n\r\tUART Transmit Interrupt");
  LoRa_UART_Transmit_Interrupt_Flag = false; // clear flag
 } 
 if(LoRa_UART_Receive_Interrupt_Enable && LoRa_UART_Receive_Interrupt_Flag) // Receiver-data-available interrupt
 {
  LoRa_UART_Receive_Interrupt_Enable = false;
  LoRa_UART_Receive_Interrupt_Flag = false; // clear flag
 }
 if(LoRa_UART_Error_Interrupt_Enable && LoRa_UART_Error_Interrupt_Flag) // UART-error interrupt
 {
  printf("\n\r\tUART-error interrupt");
  if (LoRa_UART_Parity_Error_Status) // Parity Error
  {
   printf("\n\r\t\tParity Error");
  }
  if (LoRa_UART_Framing_Error_Status) // Framing Error
  {
   printf("\n\r\t\tFraming Error");
  }
  if (LoRa_UART_Receive_Buffer_Overflow_Status) // RX Buffer Overflow
  {
   printf("\n\r\t\tRX Buffer Overflow");
  }
  LoRa_UART_Error_Interrupt_Flag = false; // clear flag
 }
}

#endif	/* INTERRUPT_CONFIG_UART_LORA_H */

