/* 
 * File:   lora_config.h
 * Author: cstgeo
 *
 * Created on March 1, 2018, 11:10 PM
 */

#ifndef LORA_CONFIG_H
#define	LORA_CONFIG_H
#include "config.h"
char totalAttempt[25];
#define UART_6_Receive_Interrupt_Enable IEC2bits.U6RXIE
#define GPS_UART_Receive_Interrupt_Enable UART_6_Receive_Interrupt_Enable

typedef enum { INITIALIZING,
               CONFIGURING,
               TRANSCEIVER_ENABLED,
               INITIALIZATION_ERROR,
               CONFIGURATION_ERROR
} LORA_STATE;
LORA_STATE lora_state = INITIALIZING;

typedef enum { LORA_UART_RECEIVING_STRING,/* -> */LORA_UART_STRING_RECEIVED,/* -> */LORA_UART_STRING_READ,
} LORA_UART_STATE;
LORA_UART_STATE lora_uart_state = LORA_UART_RECEIVING_STRING;

typedef enum { NOT_CONFIGURED,
               PAUSING_LORAWAN,
               SETTING_RADIO_POWER,
               SETTING_WATCHDOG_TIMER,
               CONFIGURATION_COMPLETE,
               PAUSE_LORAWAN_ERROR,
               SET_RADIO_POWER_ERROR,
               SET_WATCHDOG_TIMER_ERROR
} LORA_CONFIGURATION_STATE;
LORA_CONFIGURATION_STATE lora_configuration_state = NOT_CONFIGURED;

typedef enum { NOT_ENABLED, IDLE_LoRa,
               TRANSMISSION_STARTING,/* -> */TRANSMITTING,
               RECEPTION_STARTING,/* -> */RECEIVING
} LORA_TRANSCEIVER_STATE;
LORA_TRANSCEIVER_STATE lora_transceiver_state = NOT_ENABLED;


typedef enum { CONTINUOUS_RECEPTION,
               CONTINUOUS_TRANSMISSION,
               TRANSMIT_DATA_ONCE_EVERY_N_TIMER_CYCLES_ELSE_RECEIVE
} LORA_TRANSCEIVER_MODE;


#define received_string_length 250
#define received_data_offset 10
unsigned char received_string[received_string_length];
unsigned int received_string_index = 0;
#define lora_initialized_condition received_string[0] == 'R'
#define lora_mac_paused_condition received_string[0] == '4'
#define lora_radio_power_set_condition received_string[0] == 'o'
#define lora_watchdog_timer_set_condition received_string[0] == 'o'
#define lora_rx_receiving_condition received_string[0] == 'o'
#define lora_tx_transmitting_condition received_string[0] == 'o'
#define lora_rx_received_condition received_string[0] == 'r'
#define lora_tx_transmitted_condition received_string[0] == 'r'

#define mac_pause lora_configuration_state = PAUSING_LORAWAN;\
                  printf("[PIC32 -> LoRa]:\t" "mac pause\r\n"); __XC_UART = 2;\
                  printf("mac pause\r\n"); __XC_UART = 1
#define radio_set_pwr(n) lora_configuration_state = SETTING_RADIO_POWER;\
                         printf("[PIC32 -> LoRa]:\t" "radio set pwr " #n "\r\n"); __XC_UART = 2;\
                         printf("radio set pwr " #n "\r\n"); __XC_UART = 1
#define radio_set_wdt(n) lora_configuration_state = SETTING_WATCHDOG_TIMER;\
                         printf("[PIC32 -> LoRa]:\t" "radio set wdt " #n "\r\n"); __XC_UART = 2;\
                         printf("radio set wdt " #n "\r\n"); __XC_UART = 1
#define radio_tx(n) lora_transceiver_state = TRANSMISSION_STARTING;\
                    printf("[PIC32 -> LoRa]:\t" "radio tx " #n "\r\n"); __XC_UART = 2;\
                    printf("radio tx " #n "\r\n"); __XC_UART = 1
#define radio_tx_loop(n)    lora_transceiver_state = TRANSMISSION_STARTING;\
                            int i = 0;\
                            int tempInt = 0; __XC_UART = 2;\
                            printf("radio tx ");\
                            for (i = 0; i < sizeof(n)/sizeof(char); i++){\
                                tempInt = (int)n[i];\
                                printf("%X", tempInt);\
                            }\
                            printf("\r\n"); __XC_UART = 1;\
                            printf("radio tx ");\
                            for (i = 0; i < sizeof(n)/sizeof(char); i++){\
                                tempInt = (int)n[i];\
                                printf("%X", tempInt);\
                            }\
                            printf("\r\n");
                            
#define radio_rx(n) lora_transceiver_state = RECEPTION_STARTING;\
                    printf("[PIC32 -> LoRa]:\t" "radio rx " #n "\r\n"); __XC_UART = 2;\
                    printf("radio rx " #n "\r\n"); __XC_UART = 1


void function_that_does_something_with_data(unsigned char data[]);
bool isRX = true;
int test_send_int;
int i = 0;
int test_send_int = 0;
void LoRa() {
 if (lora_transceiver_state == IDLE_LoRa && lora_uart_state == LORA_UART_STRING_READ) {
     if (SWITCH_COMMAND == ARM_ROVER) {
  isRX = !isRX;
  if (isRX) {
   radio_rx(333);
  } else {
      delay_ms(250);
      radio_tx_loop(totalAttempt);
//      GPS_RESET = 0;
//      delay_ms(100);
//      GPS_RESET = 1;
      newDataRead = false;
      GPS_UART_Receive_Interrupt_Enable = 1;
  }
     }
     else {
         radio_rx(0);
     }
  
  } else if (lora_uart_state == LORA_UART_STRING_RECEIVED) {
   lora_uart_state = LORA_UART_STRING_READ;
   printf("[LoRa -> PIC32]:\t%s", received_string);
   switch (lora_transceiver_state) {
    case NOT_ENABLED: switch (lora_configuration_state) {
                       case NOT_CONFIGURED:         if (lora_initialized_condition       ) { mac_pause;         } break;
                       case PAUSING_LORAWAN:        if (lora_mac_paused_condition        ) { radio_set_pwr(20); } break;
                       case SETTING_RADIO_POWER:    if (lora_radio_power_set_condition   ) { radio_set_wdt(0);  } break;
                       case SETTING_WATCHDOG_TIMER: if (lora_watchdog_timer_set_condition) { 
                        lora_configuration_state = CONFIGURATION_COMPLETE;
                        printf("\t...LoRa configuration complete...\n\r");
                        lora_transceiver_state = IDLE_LoRa;
                       } break;
                      }
		      break;
    case TRANSMISSION_STARTING: if (lora_tx_transmitting_condition) { lora_transceiver_state = TRANSMITTING; } break;
    case RECEPTION_STARTING: if (lora_rx_receiving_condition) {
			      lora_transceiver_state = RECEIVING;
			      printf("\t...LoRa module waiting to receive...\n\r");
			     } break;
    case TRANSMITTING: if (lora_tx_transmitted_condition) {
			lora_transceiver_state = IDLE_LoRa;
		       } break;
    case RECEIVING: if (lora_rx_received_condition) {
		     lora_transceiver_state = IDLE_LoRa; 
		     function_that_does_something_with_data(received_string + received_data_offset);
		    } break;
   }
  }
}

#endif	/* LORA_CONFIG_H */