/* 
 * File:   timer_config.h
 * Author: Chris St. George
 */

#ifndef TIMER_CONFIG_H
#define	TIMER_CONFIG_H

#include "config.h"

// Timer 1
#define Timer_1_On T1CONbits.TON
#define Timer_1_Gated T1CONbits.TGATE
#define Timer_1_Source_Select T1CONbits.TCS
#define Timer_1_Prescale_Select T1CONbits.TCKPS
#define Timer_1_Prescale_1 Timer_1_Prescale_Select = 0b00
#define Timer_1_Prescale_8 Timer_1_Prescale_Select = 0b01
#define Timer_1_Prescale_64 Timer_1_Prescale_Select = 0b10
#define Timer_1_Prescale_256 Timer_1_Prescale_Select = 0b11
#define Timer_1_Count TMR1
#define Timer_1_Period PR1

// Timer 2 
#define Timer_2_On T2CONbits.TON
#define Timer_2_Gated T2CONbits.TGATE
#define Timer_2_Source_Select T1CONbits.TCS
#define Timer_2_Prescale_Select T2CONbits.TCKPS
#define Timer_2_Prescale_1 Timer_2_Prescale_Select = 0b000
#define Timer_2_Prescale_2 Timer_2_Prescale_Select = 0b001
#define Timer_2_Prescale_4 Timer_2_Prescale_Select = 0b010
#define Timer_2_Prescale_8 Timer_2_Prescale_Select = 0b011
#define Timer_2_Prescale_16 Timer_2_Prescale_Select = 0b100
#define Timer_2_Prescale_32 Timer_2_Prescale_Select = 0b101
#define Timer_2_Prescale_64 Timer_2_Prescale_Select = 0b110
#define Timer_2_Prescale_256 Timer_2_Prescale_Select = 0b111
#define Timer_2_Count TMR2
#define Timer_2_Period PR2

// Timer 3
#define Timer_3_On T3CONbits.TON
#define Timer_3_Gated T3CONbits.TGATE
#define Timer_3_Source_Select T1CONbits.TCS
#define Timer_3_Prescale_Select T3CONbits.TCKPS
#define Timer_3_Prescale_1 Timer_3_Prescale_Select = 0b000
#define Timer_3_Prescale_2 Timer_3_Prescale_Select = 0b001
#define Timer_3_Prescale_4 Timer_3_Prescale_Select = 0b010
#define Timer_3_Prescale_8 Timer_3_Prescale_Select = 0b011
#define Timer_3_Prescale_16 Timer_3_Prescale_Select = 0b100
#define Timer_3_Prescale_32 Timer_3_Prescale_Select = 0b101
#define Timer_3_Prescale_64 Timer_3_Prescale_Select = 0b110
#define Timer_3_Prescale_256 Timer_3_Prescale_Select = 0b111
#define Timer_3_Count TMR3
#define Timer_3_Period PR3

// Timer 4
#define Timer_4_On T4CONbits.TON
#define Timer_4_Gated T4CONbits.TGATE
#define Timer_4_Source_Select T1CONbits.TCS
#define Timer_4_Prescale_Select T4CONbits.TCKPS
#define Timer_4_Prescale_1 Timer_4_Prescale_Select = 0b000
#define Timer_4_Prescale_2 Timer_4_Prescale_Select = 0b001
#define Timer_4_Prescale_4 Timer_4_Prescale_Select = 0b010
#define Timer_4_Prescale_8 Timer_4_Prescale_Select = 0b011
#define Timer_4_Prescale_16 Timer_4_Prescale_Select = 0b100
#define Timer_4_Prescale_32 Timer_4_Prescale_Select = 0b101
#define Timer_4_Prescale_64 Timer_4_Prescale_Select = 0b110
#define Timer_4_Prescale_256 Timer_4_Prescale_Select = 0b111
#define Timer_4_Count TMR4
#define Timer_4_Period PR4

// Timer 5
#define Timer_5_On T5CONbits.TON
#define Timer_5_Gated T5CONbits.TGATE
#define Timer_5_Source_Select T1CONbits.TCS
#define Timer_5_Prescale_Select T5CONbits.TCKPS
#define Timer_5_Prescale_1 Timer_5_Prescale_Select = 0b000
#define Timer_5_Prescale_2 Timer_5_Prescale_Select = 0b001
#define Timer_5_Prescale_4 Timer_5_Prescale_Select = 0b010
#define Timer_5_Prescale_8 Timer_5_Prescale_Select = 0b011
#define Timer_5_Prescale_16 Timer_5_Prescale_Select = 0b100
#define Timer_5_Prescale_32 Timer_5_Prescale_Select = 0b101
#define Timer_5_Prescale_64 Timer_5_Prescale_Select = 0b110
#define Timer_5_Prescale_256 Timer_5_Prescale_Select = 0b111
#define Timer_5_Count TMR5
#define Timer_5_Period PR5

/*<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>*/

// LED Timer (Timer 2)
#define PWM_Timer_On Timer_2_On
#define PWM_Timer_Gated Timer_2_Gated
#define PWM_Timer_Source_Select Timer_2_Source_Select
#define PWM_Timer_Prescale_Select Timer_2_Prescale_Select
#define PWM_Timer_Prescale_1 Timer_2_Prescale_1
#define PWM_Timer_Prescale_4 Timer_2_Prescale_2
#define PWM_Timer_Prescale_8 Timer_2_Prescale_8
#define PWM_Timer_Prescale_16 Timer_2_Prescale_16
#define PWM_Timer_Prescale_64 Timer_2_Prescale_64
#define PWM_Timer_Prescale_256 Timer_2_Prescale_256
#define PWM_Timer_Count Timer_2_Count
#define PWM_Timer_Period Timer_2_Period

#define MEASURE_Timer_On Timer_4_On
#define MEASURE_Timer_Gated Timer_4_Gated
#define MEASURE_Timer_Source_Select Timer_4_Source_Select
#define MEASURE_Timer_Prescale_Select Timer_4_Prescale_Select
#define MEASURE_Timer_Prescale_1 Timer_4_Prescale_1
#define MEASURE_Timer_Prescale_8 Timer_4_Prescale_8
#define MEASURE_Timer_Prescale_64 Timer_4_Prescale_64
#define MEASURE_Timer_Prescale_256 Timer_4_Prescale_256
#define MEASURE_Timer_Count Timer_4_Count
#define MEASURE_Timer_Period Timer_4_Period

#define DRIVE_Timer_On Timer_3_On
#define DRIVE_Timer_Gated Timer_3_Gated
#define DRIVE_Timer_Source_Select Timer_3_Source_Select
#define DRIVE_Timer_Prescale_Select Timer_3_Prescale_Select
#define DRIVE_Timer_Prescale_1 Timer_3_Prescale_1
#define DRIVE_Timer_Prescale_8 Timer_3_Prescale_8
#define DRIVE_Timer_Prescale_64 Timer_3_Prescale_64
#define DRIVE_Timer_Prescale_256 Timer_3_Prescale_256
#define DRIVE_Timer_Count Timer_3_Count
#define DRIVE_Timer_Period Timer_3_Period

#define DEPLOY_Timer_On Timer_5_On
#define DEPLOY_Timer_Gated Timer_5_Gated
#define DEPLOY_Timer_Source_Select Timer_5_Source_Select
#define DEPLOY_Timer_Prescale_Select Timer_5_Prescale_Select
#define DEPLOY_Timer_Prescale_1 Timer_5_Prescale_1
#define DEPLOY_Timer_Prescale_8 Timer_5_Prescale_8
#define DEPLOY_Timer_Prescale_64 Timer_5_Prescale_64
#define DEPLOY_Timer_Prescale_256 Timer_5_Prescale_256
#define DEPLOY_Timer_Count Timer_5_Count
#define DEPLOY_Timer_Period Timer_5_Period

#define PWM_Period 24975
#define MEASURE_Period 40000
#define DRIVE_Period 3000
#define DEPLOY_Period 10000

void configure_PWM_timer() {
    printf("\r\nconfigure_timer_2()");
    PWM_Timer_Prescale_8;
    PWM_Timer_Count = 0;
    PWM_Timer_Period = PWM_Period;
    PWM_Timer_Source_Select = 1;
    PWM_Timer_On = false;
}
void configure_measure_timer() {
    printf("\r\nconfigure_timer_4()");
    MEASURE_Timer_Prescale_256;
    MEASURE_Timer_Count = 0;
    MEASURE_Timer_Period = MEASURE_Period;
    MEASURE_Timer_Source_Select = 1;
    MEASURE_Timer_On = false;
}
void configure_drive_timer() {
    printf("\r\nconfigure_timer_3()");
    DRIVE_Timer_Prescale_1;
    DRIVE_Timer_Count = 0;
    DRIVE_Timer_Period = DRIVE_Period;
    DRIVE_Timer_Source_Select = 1;
    DRIVE_Timer_On = false;    
}
void configure_deploy_timer() {
    printf("\r\nconfigure_timer_5()");
    DEPLOY_Timer_Prescale_256;
    DEPLOY_Timer_Count = 0;
    DEPLOY_Timer_Period = DEPLOY_Period;
    DEPLOY_Timer_Source_Select = 1;
    DEPLOY_Timer_On = false;  
}
void configure_timers() {
    configure_PWM_timer();
    configure_measure_timer();
    configure_drive_timer();
    configure_deploy_timer();
}
void timer_test(void) {    
    MEASURE_Timer_On = true;
    DRIVE_Timer_On = true;
    DEPLOY_Timer_On = true;
    PWM_Timer_On = true;
}
#endif	/* TIMER_CONFIG_H */

