/* File:   uart_config.h
 * Author: cstgeorg
 */

#ifndef UART_CONFIG_H
#define	UART_CONFIG_H
#include "config.h"



// UART Definitions
#define baudPC 57600
#define baudGPS 9600
#define baudLoRa 57600
#define baudBLE 115200
#define BR1 baudPC
#define BR2 baudLoRa
#define BR6 baudGPS
#define BRG1 FPB/4/BR1 - 1
#define BRG2 FPB/4/BR2 - 1
#define BRG6 FPB/4/BR6 - 1
#define GPS_SetBaudRateCommand "$PMTK251,115200*27\r\n"

//#define printfToUART(x) __XC_UART = (x == 2 ?  2 : 1) /* directs output of printf function through UARTx */ 
//
//#define printfToPC printfToUART(1)
//#define print(String,...) if(__XC_UART != 1) {unsigned char saved_uart_state = __XC_UART; printfToPC; printf(String,##__VA_ARGS__); __XC_UART = saved_uart_state;}\
//                          else {printf(String,##__VA_ARGS__);}
//#define printfToLORA print("Printing to LoRa\r\n"); printfToUART(2)
//#define printfToMUX(x) print("Printing to MUX(%i)\r\n",x); muxToInput(x); printfToUART(6)
//#define printfToBLE1 print("Printing to BLE1\r\n"); muxToBLE1; printfToUART(6)
//#define printfToBLE2 print("Printing to BLE2\r\n"); muxToBLE2; printfToUART(6)
//#define printfToBLE3 print("Printing to BLE3\r\n"); muxToBLE3; printfToUART(6)
//#define printfToGPS print("Printing to GPS\r\n"); muxToGPS; printfToUART(6)

#define printUARTsettings(x) printf("\n\r" "UART " #x " Setup:"\
                                   "\n\r\t" "BRG:\t%i"\
                                   "\n\r\t" "BR:\t%i bps"\
                                   "\n\r\t" "SCLK:\t%i MHz"\
                                   "\n\r\t" "PBF:\t%i MHz", U##x##BRG, BR##x, SCLK/1000000, FPB/1000000)

//void _mon_putc (char c)
//{
// switch (__XC_UART)
// {
//  case 1:
//   while (U1STAbits.UTXBF); // Wait till transmission is complete
//   U1TXREG = c;
//   break;
//  case 2:
//   while (U2STAbits.UTXBF); // Wait till transmission is complete
//   U2TXREG = c;
//   break;
//  case 3:
//   while (U3STAbits.UTXBF); // Wait till transmission is complete
//   U3TXREG = c;
//   break;
//  case 4:
//   while (U4STAbits.UTXBF); // Wait till transmission is complete
//   U4TXREG = c;
//   break;
//  case 5:
//   while (U5STAbits.UTXBF); // Wait till transmission is complete
//   U5TXREG = c;
//   break;
//  case 6:
//   while (U6STAbits.UTXBF); // Wait till transmission is complete
//   U6TXREG = c;
//   break;
//  default: exit(1);
// }
//}

int u1rx_count = 0;
unsigned char getU1()
{
 while(!U1STAbits.URXDA);
// u1rx_count++;
 return U1RXREG;
}
void putU1(unsigned char c)
{
 while(U1STAbits.UTXBF);
 U1TXREG = c;
}

int u2rx_count = 0;
unsigned char getU2()
{
 while(!U2STAbits.URXDA){
 }
// u2rx_count++;
 return U2RXREG;
}
void putU2(unsigned char c)
{
    
 while(U2STAbits.UTXBF);
 U2TXREG = c;
}

int u6rx_count = 0;
unsigned char getU6()
{
 while(!U6STAbits.URXDA);
// u6rx_count++;
 return U6RXREG;
}
void putU6(unsigned char c)
{
 while(U6STAbits.UTXBF);
 U6TXREG = c;
}

void configure_uart() {
  __XC_UART = 1;
  /* Setup UART 1 */
		  // Enable UART
		  U1MODEbits.UARTEN = true;
		  U1STAbits.URXEN = true;
		  U1MODEbits.BRGH = true;
		  U1BRG = BRG1;
		  
 /* Setup UART 2 */
		  // Enable UART
		  U2MODEbits.UARTEN = true;
		  U2STAbits.URXEN = true;
		  U2MODEbits.BRGH = true;
		  U2BRG = BRG2;
		  
 /* Setup UART 6 */
		  // Enable UART
		  U6MODEbits.UARTEN = true;
		  U6STAbits.URXEN = true;
		  U6MODEbits.BRGH = true;
		  U6BRG = BRG6;
          printf("Configure UART Complete \n\r");
}

#endif	/* UART_CONFIG_H */

